/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "RunMean_1.h"
#include <device.h>

/* local variables */

int32 RunMeanArray[1024] ; // Буфер данных для осреднения. Size_Buffer - вычисляемый locals элемент = 2^Range_of_Filter 
int16 Mean_Range = RunMean_1_Mean_Range; //Читаем настройки фильтра (степень осреднения)

/*****************************************************************************/

int32 RunMean_1_Get(int32 Sampl,int32 SIGNAL_SLOPE)   // скользящее среднее с порогом переинициализации
{
int32 i ;
int32 outdata ;     //результат
int32 sum ;         //сумма значений кольцевого буфера
int16 index;        //индекс кольцевого буфера

    if(abs(outdata-Sampl)>SIGNAL_SLOPE) //порог сброса фильтра осреднения
    {
        for(i = 0; i< MAX_SAMPLE; i++)  RunMeanArray[i] = Sampl; // заполняем буфер новым значением
        sum = Sampl << Mean_Range ;     //вычисляем сумму буфера
        outdata = Sampl;                // результат
        index = 0;  
    }
    else     
    {    
        sum = sum - RunMeanArray[index];    // удаляем старый элемент
        sum = sum + Sampl;                  // добавим новый
        outdata = sum >> Mean_Range;        // результат
        RunMeanArray[index] = Sampl;        // сохраняем новый элемент в кольцевом буфере
        index++;                            
        if (index == MAX_SAMPLE)      index = 0;    // следующая ячейка буфера
    }    
return( outdata);    
}
/* [] END OF FILE */
