/*******************************************************************************
* Potentiometer - PORT 6[5] 
* LCD - PORT 2[0..6]
*******************************************************************************/
#include <device.h>
#include "stdio.h"
#include "stdlib.h"

int32 result = 0;           // Variable to hold ADC conversion result
int32 averageCounts = 0;    // Variable to hold the moving average filtered value 
int32 SLOPE =2000;                // порог переинициализации фильтра в дискретах, а не микровольтах

void main(void)
{
    int32 microVolts = 0;   //result in micro volts converted from filtered * ADC counts 
    char displayStr[15] = {'\0'};  // Character array to hold the micro volts      

    CYGlobalIntEnable;      //прерывания понадобятся АЦП
    ADC_Start();            /* Start ADC and start conversion */
    ADC_SetOffset(-23);	    //Смещение в дискретах (по ADC_GetResult..(), то же число с тем же знаком)
   //ADC_SetGain(317000);   //Дискрет на 1 вольт (меряем U эталонное и делим на него ADC_GetResult..()    )
    ADC_StartConvert();
    LCD_Start();            /* Start LCD and set position */
 
    while(1)
    {
        ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);   //ждем конца преобразования
        result = ADC_GetResult32();                 // читаем результат
        
    averageCounts = RunMean_Get(result,SLOPE);    //Скользящее среднее с порогом
    
        microVolts = ADC_CountsTo_uVolts(averageCounts);    //пересчет в микровольты
        sprintf(displayStr,"%9ld mkV",microVolts);         // Convert micro volts to string 
        LCD_Position(0,0);                                  //and display on the LCD
        LCD_PrintString(displayStr);
    }	
}












